diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
index 2cc84dcf1..6bd32029e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
@@ -323,7 +323,7 @@ public class ScreenSelectWorld extends Screen {
 
             long sizeBytes = saveFile.getSizeOnDisk();
             this.descBuilder1.append(saveFile.getFileName());
-            this.descBuilder1.append(" (").append(ScreenSelectWorld.this.dateFormatter.format(new Date(saveFile.getLastTimePlayed())));
+            this.descBuilder1.append(" (").append(ScreenSelectWorld.this.dateFormatter.format(new Date(saveFile.getLastTimePlayed())).replace("\u202f", " ")); // removes the nnbsp
             this.descBuilder1.append(", ").append((float) (((sizeBytes / 1024L) * 100L) / 1024L) / 100F).append(" MB)");
 
             if (saveFile.getNeedsConversion()) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBubble.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBubble.java
index 7bd0d81f1..00f16acfb 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBubble.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBubble.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.particle.ParticleBubble;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 
 public class ParticleEntryBubble extends ParticleEntryGeneric {
@@ -10,6 +11,6 @@ public class ParticleEntryBubble extends ParticleEntryGeneric {
     }
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.particleEngine.add(new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, false));
+        mc.particleEngine.add(new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, Dimension.OVERWORLD, false));
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index ca2d2fdf6..ae7b567d7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -173,7 +173,7 @@ public abstract class OptionsPages {
                     .withComponent(new FloatOptionComponent(GameSettings.COLOR_CORRECTION))
                     .withComponent(new FloatOptionComponent(GameSettings.FXAA))
                     .withComponent(new ToggleableOptionComponent<>(GameSettings.BLOOM))
-                    .withComponent(new BooleanOptionComponent(GameSettings.HEAT_HAZE))
+                    .withComponent(new FloatOptionComponent(GameSettings.HEAT_HAZE))
                 )
                 .withComponent(new OptionsCategory("gui.options.page.video.category.performance")
                     .withComponent(new ToggleableOptionComponent<>(GameSettings.RENDER_DISTANCE))
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 8ea3fa761..8e2113959 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -373,7 +373,7 @@ public final class GameSettings {
             return option.toOptionsString();
         }));
     public static final @NotNull OptionEnum<RenderScale> RENDER_SCALE = register(new OptionEnum<>("renderScale", RenderScale.class, RenderScale.SCALE_100));
-    public static final @NotNull OptionBoolean HEAT_HAZE = register(new OptionBoolean("heatHaze", false));
+    public static final @NotNull OptionFloat HEAT_HAZE = register(new OptionFloat("heatHaze", 0));
     public static final @NotNull OptionBoolean ALPHA_MENU = register(new OptionBoolean("old", false));
     public static final @NotNull OptionBoolean ENABLE_ITEM_CLUMPING = register(new OptionBoolean("enableItemClumping", true));
     public static final @NotNull OptionEnum<DescriptionPromptEnum> ITEM_DESCRIPTIONS = register(new OptionEnum<>("itemDescriptions", DescriptionPromptEnum.class, DescriptionPromptEnum.PROMPT));
diff --git a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index cb2e8cf61..7a1fabc4a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -68,7 +68,8 @@ public class PostProcessingManager {
         if (this.mc.currentWorld == null || this.mc.thePlayer == null) return;
 
         this.reset();
-        if (GameSettings.COLOR_CORRECTION.value == 0) return;
+        float ccValue = GameSettings.COLOR_CORRECTION.value;
+        boolean haze = GameSettings.HEAT_HAZE.value != 0;
 
         final float y = (float) this.mc.thePlayer.y;
         final int maxY = this.mc.currentWorld.getWorldType().getMaxY(this.mc.currentWorld);
@@ -107,67 +108,73 @@ public class PostProcessingManager {
         }
 
         // Perform season effects
-        float seasonProgress = this.mc.currentWorld.getSeasonManager().getSeasonProgress(); // Ranges from 0.0 to 1.0
-        seasonProgress = (seasonProgress * 2) - 1f; // Ranges from -1.0 to 1.0
-        seasonProgress = Math.abs(seasonProgress); // Ranges from 1.0 to 0.0 to 1.0
-        seasonProgress = -seasonProgress + 1.0f; // Ranges from 0.0 to 1.0 to 0.0
-        if (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING) {
-            this.current.saturation += 0.1f * seasonProgress * surfaceness;
-        } else if (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER) {
-            this.current.rMod += 0.1f * seasonProgress * surfaceness;
-            this.current.gMod += 0.1f * seasonProgress * surfaceness;
-        } else if (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL) {
-            this.current.contrast -= 0.1f * seasonProgress * surfaceness;
-            this.current.rMod += 0.1f * seasonProgress * surfaceness;
-        } else if (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER) {
-            this.current.contrast -= 0.1f * seasonProgress * surfaceness;
-            this.current.bMod += 0.1f * seasonProgress * surfaceness;
+        if (ccValue != 0) {
+            float seasonProgress = this.mc.currentWorld.getSeasonManager().getSeasonProgress(); // Ranges from 0.0 to 1.0
+            seasonProgress = (seasonProgress * 2) - 1f; // Ranges from -1.0 to 1.0
+            seasonProgress = Math.abs(seasonProgress); // Ranges from 1.0 to 0.0 to 1.0
+            seasonProgress = -seasonProgress + 1.0f; // Ranges from 0.0 to 1.0 to 0.0
+            if (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING) {
+                this.current.saturation += 0.1f * seasonProgress * surfaceness;
+            } else if (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER) {
+                this.current.rMod += 0.1f * seasonProgress * surfaceness;
+                this.current.gMod += 0.1f * seasonProgress * surfaceness;
+            } else if (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL) {
+                this.current.contrast -= 0.1f * seasonProgress * surfaceness;
+                this.current.rMod += 0.1f * seasonProgress * surfaceness;
+            } else if (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER) {
+                this.current.contrast -= 0.1f * seasonProgress * surfaceness;
+                this.current.bMod += 0.1f * seasonProgress * surfaceness;
+            }
         }
 
         // Perform weather effects
-        final Weather activeWeather = this.mc.currentWorld.getCurrentWeather();
-        if (activeWeather != null) {
-            final float intensity = this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherIntensity();
-            if (activeWeather == Weathers.OVERWORLD_SNOW || activeWeather == Weathers.OVERWORLD_WINTER_SNOW) {
-                this.current.contrast += -0.125f * intensity * surfaceness;
-                this.current.saturation += -0.25f * intensity * surfaceness;
-                this.current.bMod += 0.25f * intensity * surfaceness;
-            } else if (activeWeather == Weathers.OVERWORLD_RAIN_BLOOD) {
-                this.current.rMod += 0.4f * intensity * surfaceness;
-                this.current.gMod += 0.1f * intensity * surfaceness;
-                this.current.saturation += 0.125f * intensity * surfaceness;
-                this.current.exposure -= 0.125f * intensity * surfaceness;
-            } else if (activeWeather == Weathers.OVERWORLD_RAIN) {
-                this.current.bMod += 0.1f * intensity * surfaceness;
-                this.current.saturation += -0.125f * intensity * surfaceness;
-                this.current.brightness += -0.0625f * intensity * surfaceness;
-            } else if (activeWeather == Weathers.OVERWORLD_STORM) {
-                this.current.bMod += 0.1f * intensity * surfaceness;
-                this.current.saturation += -0.2f * intensity * surfaceness;
-                this.current.brightness += -0.1f * intensity * surfaceness;
-            } else if (activeWeather == Weathers.OVERWORLD_FOG && GameSettings.FOG.value) {
-                this.current.saturation += -0.4f * intensity * surfaceness;
-                this.current.contrast += -0.25f * intensity * surfaceness;
+        if (ccValue != 0) {
+            final Weather activeWeather = this.mc.currentWorld.getCurrentWeather();
+            if (activeWeather != null) {
+                final float intensity = this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherIntensity();
+                if (activeWeather == Weathers.OVERWORLD_SNOW || activeWeather == Weathers.OVERWORLD_WINTER_SNOW) {
+                    this.current.contrast += -0.125f * intensity * surfaceness;
+                    this.current.saturation += -0.25f * intensity * surfaceness;
+                    this.current.bMod += 0.25f * intensity * surfaceness;
+                } else if (activeWeather == Weathers.OVERWORLD_RAIN_BLOOD) {
+                    this.current.rMod += 0.4f * intensity * surfaceness;
+                    this.current.gMod += 0.1f * intensity * surfaceness;
+                    this.current.saturation += 0.125f * intensity * surfaceness;
+                    this.current.exposure -= 0.125f * intensity * surfaceness;
+                } else if (activeWeather == Weathers.OVERWORLD_RAIN) {
+                    this.current.bMod += 0.1f * intensity * surfaceness;
+                    this.current.saturation += -0.125f * intensity * surfaceness;
+                    this.current.brightness += -0.0625f * intensity * surfaceness;
+                } else if (activeWeather == Weathers.OVERWORLD_STORM) {
+                    this.current.bMod += 0.1f * intensity * surfaceness;
+                    this.current.saturation += -0.2f * intensity * surfaceness;
+                    this.current.brightness += -0.1f * intensity * surfaceness;
+                } else if (activeWeather == Weathers.OVERWORLD_FOG && GameSettings.FOG.value) {
+                    this.current.saturation += -0.4f * intensity * surfaceness;
+                    this.current.contrast += -0.25f * intensity * surfaceness;
+                }
             }
         }
 
         // Perform dimension effects
-        if (this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.HOT)) {
+        if ((ccValue != 0 || haze) && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.HOT)) {
             float scale = 1.0f;
             if (this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.NETHER) && temperature < 0.5) {
                 scale = (float) temperature * 2.0f;
             }
-            this.current.rMod += 1.2f * scale;
-            this.current.gMod += 0.3f * scale;
-            this.current.saturation += 0.125f * scale;
-            this.current.exposure -= 0.125f;
-            this.current.contrast -= 0.05f;
-            this.current.brightness -= 0.05f;
-            this.current.heatHaze = scale;
+            if (ccValue != 0) {
+                this.current.rMod += 1.2f * scale;
+                this.current.gMod += 0.3f * scale;
+                this.current.saturation += 0.125f * scale;
+                this.current.exposure -= 0.125f;
+                this.current.contrast -= 0.05f;
+                this.current.brightness -= 0.05f;
+            }
+            if (haze) this.current.heatHaze = scale;
         }
 
         // Perform heatwave effects
-        if (this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.OVERWORLD) && (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER || this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL)) {
+        if (haze && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.OVERWORLD) && (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER || this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL)) {
             if (temperature >= 0.85 && humidity <= 0.15) {
                 final double tPercentage = (temperature - 0.85) / 0.15;
                 final double hPercentage = 1 - (humidity / 0.15);
@@ -178,24 +185,27 @@ public class PostProcessingManager {
         }
 
         // Scaling
-        if (GameSettings.COLOR_CORRECTION.value != 0) {
-            this.current.brightness *= GameSettings.COLOR_CORRECTION.value;
-            this.current.contrast *= GameSettings.COLOR_CORRECTION.value;
-            this.current.exposure *= GameSettings.COLOR_CORRECTION.value;
-            this.current.saturation *= GameSettings.COLOR_CORRECTION.value;
-            this.current.rMod = 1.0f - (1.0f - this.current.rMod) * GameSettings.COLOR_CORRECTION.value;
-            this.current.gMod = 1.0f - (1.0f - this.current.gMod) * GameSettings.COLOR_CORRECTION.value;
-            this.current.bMod = 1.0f - (1.0f - this.current.bMod) * GameSettings.COLOR_CORRECTION.value;
+        if (ccValue != 0) {
+            this.current.brightness *= ccValue;
+            this.current.contrast *= ccValue;
+            this.current.exposure *= ccValue;
+            this.current.saturation *= ccValue;
+            this.current.rMod = 1.0f - (1.0f - this.current.rMod) * ccValue;
+            this.current.gMod = 1.0f - (1.0f - this.current.gMod) * ccValue;
+            this.current.bMod = 1.0f - (1.0f - this.current.bMod) * ccValue;
+
+            this.current.brightness = smoothLerp(this.oldCurrent.brightness, this.current.brightness);
+            this.current.contrast = smoothLerp(this.oldCurrent.contrast, this.current.contrast);
+            this.current.exposure = smoothLerp(this.oldCurrent.exposure, this.current.exposure);
+            this.current.saturation = smoothLerp(this.oldCurrent.saturation, this.current.saturation);
+            this.current.rMod = smoothLerp(this.oldCurrent.rMod, this.current.rMod);
+            this.current.gMod = smoothLerp(this.oldCurrent.gMod, this.current.gMod);
+            this.current.bMod = smoothLerp(this.oldCurrent.bMod, this.current.bMod);
+        }
+        if (haze) {
+            this.current.heatHaze *= GameSettings.HEAT_HAZE.value * 3;
+            this.current.heatHaze = smoothLerp(this.oldCurrent.heatHaze, this.current.heatHaze);
         }
-
-        this.current.brightness = smoothLerp(this.oldCurrent.brightness, this.current.brightness);
-        this.current.contrast = smoothLerp(this.oldCurrent.contrast, this.current.contrast);
-        this.current.exposure = smoothLerp(this.oldCurrent.exposure, this.current.exposure);
-        this.current.saturation = smoothLerp(this.oldCurrent.saturation, this.current.saturation);
-        this.current.rMod = smoothLerp(this.oldCurrent.rMod, this.current.rMod);
-        this.current.gMod = smoothLerp(this.oldCurrent.gMod, this.current.gMod);
-        this.current.bMod = smoothLerp(this.oldCurrent.bMod, this.current.bMod);
-        this.current.heatHaze = smoothLerp(this.oldCurrent.heatHaze, this.current.heatHaze);
     }
 
     public void render(final float partialTick) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 59dd489e1..fed8bba1c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -802,7 +802,7 @@ public class WorldRenderer {
                 rainParticlePositionY = (heightmapPosition + 0.1F) - Blocks.blocksList[blockId].getBounds().minY();
                 rainParticlePositionZ = z + blockZ;
             }
-            this.mc.particleEngine.add(new ParticleWaterDrop(world, x + blockX, (heightmapPosition + 0.1F) - Blocks.blocksList[blockId].getBounds().minY(), z + blockZ));
+            this.mc.particleEngine.add(new ParticleWaterDrop(world, x + blockX, (heightmapPosition + 0.1F) - Blocks.blocksList[blockId].getBounds().minY(), z + blockZ, world.dimension));
         }
 
         if (spawnedParticles > 0 && this.random.nextInt(3) < this.rainSoundCounter++) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index bae1ed67b..c6d332f6b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
@@ -135,10 +136,17 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
                 tessellator.addVertexWithUV(x + 1, (float) y + he, z, tex.getIconUMin(), tex.getIconVMin());
 
                 if (worldSource.getWorldType().hasTag(WorldTypeTags.NETHER) && this.block.getLogic().fluid instanceof FluidWater) {
-                    tessellator.setColorOpaque3i(
-                        ((Color.redFromInt(color) * 3) / 4) + (255/4),
-                        ((Color.greenFromInt(color) * 3) / 4) + (255/4),
-                        ((Color.blueFromInt(color) * 3) / 4) + (255/4));
+                    if (GameSettings.BIOME_WATER.value) {
+                        tessellator.setColorOpaque3i(
+                            ((Color.redFromInt(color) * 3) / 4) + (255/4),
+                            ((Color.greenFromInt(color) * 3) / 4) + (255/4),
+                            ((Color.blueFromInt(color) * 3) / 4) + (255/4));
+                    } else {
+                        tessellator.setColorOpaque3i(
+                            200,
+                            255/3,
+                            255/3);
+                    }
 
                     random.setSeed(getPositionalSeed(tilePos));
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
index 508c84db4..8c481379f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.animal.MobWolf;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.util.helper.MathHelper;
@@ -24,7 +25,9 @@ public class MobRendererWolf extends MobRenderer<MobWolf> {
     protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobWolf entity, final float brightness, final float partialTick, final int layer) {
         final StaticEntityModel model;
         if (layer == 1) {
-            final ArmorMaterial material = entity.getArmorMaterial();
+            final ItemStack armor = entity.getArmorItem();
+            if (armor == null) return null;
+            final ArmorMaterial material = ((IArmorItem<?>) armor.getItem()).getArmorMaterial();
             if (material == null) return null;
             bindTexture(String.format("/assets/%s/textures/armor/wolf/%s.png", material.identifier.namespace(), material.identifier.value()));
             model = getModel("armor");
@@ -103,7 +106,7 @@ public class MobRendererWolf extends MobRenderer<MobWolf> {
 
     @Override
     protected int maxRenderLayer(@NotNull final MobWolf entity) {
-        return entity.getArmorMaterial() != null ? 1 : 0;
+        return entity.getArmorItem() != null ? 1 : 0;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererZombieArmored.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererZombieArmored.java
index 47dc66c79..fc5928b0f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererZombieArmored.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererZombieArmored.java
@@ -24,17 +24,6 @@ public class MobRendererZombieArmored extends MobRendererBipedArmored<MobZombieA
 
         bindTexture("/assets/minecraft/textures/armor/chain" + "_" + (layer != 3 ? 1 : 2) + ".png");
 
-        // Disable armor pieces depending on health
-        final int[] armorBreakPoints = entity.getArmorBreakPoints();
-        final int[] armorBreakOrder = entity.getArmorBreakOrder();
-        for (int i = 0; i < 4; i++)
-        {
-            if (entity.getHealth() <= armorBreakPoints[i])
-            {
-                hideArmorPiece(armorBreakOrder[i]);
-            }
-        }
-
         final StaticEntityModel model;
         switch (layer) {
             case 4:
@@ -58,28 +47,46 @@ public class MobRendererZombieArmored extends MobRendererBipedArmored<MobZombieA
 
     private void hideArmorPiece(final int piece)
     {
-//        if (piece == 0)
-//        {
-//            modelArmorChestplate.head.visible = false;
-//            modelArmorChestplate.hair.visible = false;
-//        }
-//        else if (piece == 1)
-//        {
-//            modelArmorChestplate.body.visible = false;
-//            modelArmorChestplate.armLeft.visible = false;
-//            modelArmorChestplate.armRight.visible = false;
-//        }
-//        else if (piece == 2)
-//        {
-//            modelArmor.body.visible = false;
-//            modelArmor.legLeft.visible = false;
-//            modelArmor.legRight.visible = false;
-//        }
-//        else if (piece == 3)
-//        {
-//            modelArmorChestplate.legLeft.visible = false;
-//            modelArmorChestplate.legRight.visible = false;
-//        }
+        if (piece == 0)
+        {
+            StaticEntityModel model = getModel("armor.helmet");
+            model.getTransform("head").visible = false;
+            model.getTransform("chest").visible = false;
+            model.getTransform("rightArm").visible = false;
+            model.getTransform("leftArm").visible = false;
+            model.getTransform("rightLeg").visible = false;
+            model.getTransform("leftLeg").visible = false;
+        }
+        else if (piece == 1)
+        {
+            StaticEntityModel model = getModel("armor.chestplate");
+            model.getTransform("head").visible = false;
+            model.getTransform("chest").visible = false;
+            model.getTransform("rightArm").visible = false;
+            model.getTransform("leftArm").visible = false;
+            model.getTransform("rightLeg").visible = false;
+            model.getTransform("leftLeg").visible = false;
+        }
+        else if (piece == 2)
+        {
+            StaticEntityModel model = getModel("armor.leggings");
+            model.getTransform("head").visible = false;
+            model.getTransform("chest").visible = false;
+            model.getTransform("rightArm").visible = false;
+            model.getTransform("leftArm").visible = false;
+            model.getTransform("rightLeg").visible = false;
+            model.getTransform("leftLeg").visible = false;
+        }
+        else if (piece == 3)
+        {
+            StaticEntityModel model = getModel("armor.boots");
+            model.getTransform("head").visible = false;
+            model.getTransform("chest").visible = false;
+            model.getTransform("rightArm").visible = false;
+            model.getTransform("leftArm").visible = false;
+            model.getTransform("rightLeg").visible = false;
+            model.getTransform("leftLeg").visible = false;
+        }
     }
 
     @Override
@@ -107,6 +114,18 @@ public class MobRendererZombieArmored extends MobRendererBipedArmored<MobZombieA
         leftArm.rotZ -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
         rightArm.rotX += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
         leftArm.rotX -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+
+        // Disable armor pieces depending on health
+        final int[] armorBreakPoints = entity.getArmorBreakPoints();
+        final int[] armorBreakOrder = entity.getArmorBreakOrder();
+        for (int i = 0; i < 4; i++)
+        {
+            if (entity.getHealth() <= armorBreakPoints[i])
+            {
+                hideArmorPiece(armorBreakOrder[i]);
+            }
+        }
+
         return model1;
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 546314a3c..050f870af 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -429,6 +429,13 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
 
         addDispatch(new ItemModelStandard(Items.DOUGH, "minecraft"));
 
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_LEATHER, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_CHAINMAIL, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_IRON, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_DIAMOND, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_GOLD, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_STEEL, "minecraft"));
+
         for (int i = 0; i < Blocks.blocksList.length; i++) {
             if (Blocks.blocksList[i] == null) continue;
             Item item = Blocks.blocksList[i].asItem();
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
index 1587e0b04..659823227 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
@@ -2,19 +2,21 @@ package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
 
 public class ParticleBubble extends Particle {
     private final boolean needsWater;
 
-    public ParticleBubble(World world, double x, double y, double z, double xa, double ya, double za, boolean needsWater) {
+    public ParticleBubble(World world, double x, double y, double z, double xa, double ya, double za, @NotNull Dimension dimension, boolean needsWater) {
         super(world, x, y, z, xa, ya, za);
         this.needsWater = needsWater;
         this.rCol = 1.0F;
         this.gCol = 1.0F;
         this.bCol = 1.0F;
-        this.tex = TextureRegistry.getTexture("minecraft:particle/bubble");
+        this.tex = dimension == Dimension.NETHER ? TextureRegistry.getTexture("minecraft:particle/bubble_boiling") : TextureRegistry.getTexture("minecraft:particle/bubble");
         this.size = this.size * (random.nextFloat() * 0.6F + 0.2F);
         this.xd = xa * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
         this.yd = ya * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubbleBoiling.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubbleBoiling.java
index b36d3fe5f..a498892fb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubbleBoiling.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubbleBoiling.java
@@ -1,10 +1,12 @@
 package net.minecraft.client.render.particle;
 
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
 import org.joml.primitives.AABBd;
 
 public class ParticleBubbleBoiling extends Particle {
@@ -13,6 +15,7 @@ public class ParticleBubbleBoiling extends Particle {
     private final boolean needsWater;
 //    private final AABBd aabbd = new AABBd();
     private final TilePos qpos = new TilePos();
+    private final @NotNull IconCoordinate popping = TextureRegistry.getTexture("minecraft:particle/bubble_boiling_pop");
 
     public ParticleBubbleBoiling(World world, double x, double y, double z, double xa, double ya, double za, boolean needsWater) {
         super(world, x, y, z, xa, ya, za);
@@ -60,10 +63,13 @@ public class ParticleBubbleBoiling extends Particle {
         if (this.needsWater && !inWater) {
             this.lifetime = MathHelper.clamp(this.lifetime, 0, 8);
         }
-        if (this.lifetime-- <= 0) {
-            remove();
+        if (this.lifetime == 6) {
+            this.tex = this.popping;
             world.spawnParticle("smoke", x, y, z, 0.0D, 0.0D, 0.0D, 1);
+        } else if (this.lifetime <= 0) {
+            remove();
         }
+        this.lifetime--;
     }
 
 }
